<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on June 29, 2010 at 8:24:39 am</time-stamp>
<!-- Package Changes for PV-Base Extensions(Green.25,bbuxton)* -->


<methods>
<class-id>Kernel.ResolvedDeferredBinding</class-id> <category>initialize</category>

<body package="PV-Base Extensions" selector="flushBinding">flushBinding

	| mc class |
	(method ~~ nil
	and: [(mc := method mclass) ~~ nil
	and: [(class := mc instanceBehavior) isBehavior
	and: [class needsSafeRebinding]]])
		ifTrue: [self resolveBinding]
		ifFalse:
			[class := DeferredBinding.
			"The following actions must be executed atomically.
			If at some point #adoptInstance: is implemented
			as a non-primitive method which then calls the
			primitive method, this could allow a process switch
			between the nilling and the class changing, which
			can cause processes to crash. Any change to
			#adoptInstance: should take this warning into
			account."
		
			"Cincom Case 419962: removed setting resolved and resolvedValue to nil to 
			prevent a race condition with other, concurrent users of a binding.  The only
			negative side effect should be that old bindings not be able to be GCed until
			the binding is actually resolved lazily.  That shouldn't be a big deal."
			class adoptInstance: self]</body>
</methods>

<methods>
<class-id>Kernel.ResolvedDeferredConstant</class-id> <category>initialize</category>

<body package="PV-Base Extensions" selector="flushBinding">flushBinding

	| mc class |
	(method ~~ nil
	and: [(mc := method mclass) ~~ nil
	and: [(class := mc instanceBehavior) isBehavior
	and: [class needsSafeRebinding]]])
		ifTrue: [self resolveBinding]
		ifFalse:
			[class := DeferredBinding.
			"The following actions must be executed atomically.
			If at some point #adoptInstance: is implemented
			as a non-primitive method which then calls the
			primitive method, this could allow a process switch
			between the nilling and the class changing, which
			can cause processes to crash. Any change to
			#adoptInstance: should take this warning into
			account."

			"Cincom Case 419962: removed setting resolved and resolvedValue to nil to 
			prevent a race condition with other, concurrent users of a binding.  The only
			negative side effect should be that old bindings not be able to be GCed until
			the binding is actually resolved lazily.  That shouldn't be a big deal."
			class adoptInstance: self]</body>
</methods>


</st-source>
